<template>
  <div class="color-chip"
  :class="[
    'color-' + chip.color,
    { highlighted: chip.highlighted },
    { selected: chip.selected },
  ]"
  v-on:click="clicked()">
  </div>
</template>

<script lang="ts">
import { store } from '../store'
import { ColorChip } from '../types/ColorChip'

export default {
  props: {
    chip: ColorChip,
    coordinates: Object,
  },
  setup(props) {
    return {
      clicked() {
        store.dispatch('colorChipClicked', {
          chip: props.chip,
          coordinates: props.coordinates,
        });
      },
    }
  }
}
</script>

<style lang="scss">
.color-chip {
  position: absolute;
  top: 50%;
  left: 50%;
  transform: translate(-50%, -50%);
  width: 100%;
  height: 100%;
  border-radius: 50%;
  box-shadow: 0 5px 5px #0005;
  transition: 0.5s;
  &.highlighted {
    border: 10px solid;
    box-sizing: border-box;
    animation: 1s infinite highlightedColorChip;
  }
  &.selected {
    border: 5px solid #0005;
  }
  &.color-0 {
    background: #c5415a;
  }
  &.color-1 {
    background: #e8923b;
  }
  &.color-2 {
    background: #fff473;
  }
  &.color-3 {
    background: #59d76e;
  }
  &.color-4 {
    background: #2e8ab6;
  }
  &.color-5 {
    background: #8f3efa;
  }
}
@keyframes highlightedColorChip {
  0% {
    border-color: transparent;
  }
  50% {
    border-color: #ffffff99;
  }
  100% {
    border-color: transparent;
  }
}
</style>
